// Adds Servers
function switcher_addServers()
{
    window.openDialog("chrome://switcher/content/dialogs/serveradd.xul", "switcher-server-dialog", "centerscreen,chrome,modal", "add");

    // everything is set
    if(devserver && liveserver)
    {
        var listCell     = document.createElement("listcell");
        var listItem     = document.createElement("listitem");
        var resizeBox    = document.getElementById("webdeveloper-listbox");

        listCell.setAttribute("label", devserver);
        listItem.appendChild(listCell);

        listCell = document.createElement("listcell");
        listCell.setAttribute("label", liveserver);
        listItem.appendChild(listCell);

        //    resizeBox.appendChild(listItem);
        resizeBox.selectItem(resizeBox.appendChild(listItem));
        resizeBox.ensureElementIsVisible(resizeBox.selectedItem);
    }
}


// Edits Servers
function switcher_editServers()
{
    //var pageDocument = document.getElementById("webdeveloper-options-iframe").contentDocument;
    var resizeBox    = document.getElementById("webdeveloper-listbox");
    var selectedItem = resizeBox.selectedItem;

    // If an option is selected
    if(selectedItem)
    {
        window.openDialog("chrome://switcher/content/dialogs/serveradd.xul", "switcher-server-dialog", "centerscreen,chrome,modal", "edit", selectedItem.childNodes[0].getAttribute("label"), selectedItem.childNodes[1].getAttribute("label"));

        // everything is set
        if(devserver && liveserver)
        {
            var listCell = document.createElement("listcell");

            webdeveloper_removeAllChildNodes(selectedItem);

            listCell.setAttribute("label", devserver);
            selectedItem.appendChild(listCell);

            listCell = document.createElement("listcell");
            listCell.setAttribute("label", liveserver);
            selectedItem.appendChild(listCell);

            selectedItem.appendChild(listCell);
            resizeBox.ensureElementIsVisible(selectedItem);
        }
    }
}

// Removes all child nodes from a node
function webdeveloper_removeAllChildNodes(node)
{
    // If the node is set
    if(node)
    {
        var childNodes = node.childNodes;

        // Loop through the child nodes
        for(var i = 0; i < childNodes.length; i++)
        {
            node.removeChild(childNodes[i]);
        }

        childNodes = node.childNodes;

        // Loop through the child nodes
        while(childNodes.length > 0)
        {
            node.removeChild(childNodes[0]);
        }
    }
}

// Initializes the resize page
function webdeveloper_initializeResize()
{
    var devserver      = null;
    var liveserver = null;
    var devserverValue      = null;
    var liveserverValue = null;
    var listCell         = null;
    var listItem         = null;
    var pageDocument     = document;
    var resizeBox        = pageDocument.getElementById("webdeveloper-listbox");
    var resizeCount      = 0;

    // If the resize count preference is set
    if(webdeveloper_isPreferenceSet("serverswitcher.servers.count"))
    {
        resizeCount = webdeveloper_getIntegerPreference("serverswitcher.servers.count", true);
    }

    // Loop through the possible resize options
    for(var i = 1; i <= resizeCount; i++)
    {
        devserver    = "serverswitcher.servers." + i + ".devserver";
	    liveserver   = "serverswitcher.servers." + i + ".liveserver";

        // If the devserver is set
        if(webdeveloper_isPreferenceSet(devserver))
        {
            devserverValue = webdeveloper_getStringPreference(devserver, true);
        }
        else
        {
            devserverValue = null;
        }

        // If the liveserver is set
        if(webdeveloper_isPreferenceSet(liveserver))
        {
            liveserverValue = webdeveloper_getStringPreference(liveserver, true);
        }
        else
        {
            liveserverValue = null;
        }

        // If the liveserver and devserver are set
        if(devserverValue && liveserverValue)
        {
            
            listItem = pageDocument.createElement("listitem");

            listCell = pageDocument.createElement("listcell");
            listCell.setAttribute("label", devserverValue);
            listItem.appendChild(listCell);

            listCell = pageDocument.createElement("listcell");
            listCell.setAttribute("label", liveserverValue);
            listItem.appendChild(listCell);

            resizeBox.appendChild(listItem);
        }

    }

    webdeveloper_listBoxSelected();
}


// Called whenever a list box is selected
function webdeveloper_listBoxSelected()
{
    var pageDocument   = document;
    var deleteButton   = pageDocument.getElementById("webdeveloper-delete");
    var editButton     = pageDocument.getElementById("webdeveloper-edit");
    var listBox        = pageDocument.getElementById("webdeveloper-listbox");
    var moveDownButton = pageDocument.getElementById("webdeveloper-move-down");
    var moveUpButton   = pageDocument.getElementById("webdeveloper-move-up");
    var selectedIndex  = listBox.selectedIndex;

    // If an item is selected
    if(listBox.selectedItem)
    {
        deleteButton.disabled   = false;
        editButton.disabled     = false;

        // If this is the first item
        if(selectedIndex == 0)
        {
            moveUpButton.disabled = true;
        }
        else
        {
            moveUpButton.disabled = false;
        }

        // If this is the last item
        if(selectedIndex == listBox.getRowCount() - 1)
        {
            moveDownButton.disabled = true;
        }
        else
        {
            moveDownButton.disabled = false;
        }
    }
    else
    {
        deleteButton.disabled   = true;
        editButton.disabled     = true;
        moveDownButton.disabled = true;
        moveUpButton.disabled   = true;
    }
}


// Moves the selected item down
function webdeveloper_moveDown()
{
    var pageDocument  = document;
    var resizeBox     = pageDocument.getElementById("webdeveloper-listbox");
    var selectedItem  = resizeBox.selectedItem;

    // If an item is selected and it is not at the bottom
    if(selectedItem && resizeBox.selectedIndex != resizeBox.getRowCount() - 1)
    {
        resizeBox.selectItem(resizeBox.insertBefore(selectedItem, resizeBox.getNextItem(selectedItem, 2)));
    }
}

// Moves the selected item up
function webdeveloper_moveUp()
{
    var pageDocument  = document;
    var resizeBox     = pageDocument.getElementById("webdeveloper-listbox");
    var selectedItem  = resizeBox.selectedItem;

    // If an item is selected and it is not at the top
    if(selectedItem && resizeBox.selectedIndex != 0)
    {
        resizeBox.selectItem(resizeBox.insertBefore(selectedItem, resizeBox.getPreviousItem(selectedItem, 1)));
    }
}

// Deletes a resize option
function webdeveloper_deleteResize()
{
    var pageDocument = document;
    var resizeBox    = pageDocument.getElementById("webdeveloper-listbox");
    var selectedItem = resizeBox.selectedItem;

    // If an item is selected and the deletion is confirmed
    if(selectedItem)
    {
        resizeBox.removeChild(selectedItem);
    }
}


function switcher_saveOptions() {
    var resizeBox     = document.getElementById("webdeveloper-listbox");
    var resizeCount   = webdeveloper_getIntegerPreference("serverswitcher.servers.count", true);
    var devserver     = null;
    var liveserver    = null;

    // Loop through the previous resize options
    for(i = 1; i <= resizeCount; i++)
    {
        devserver  = "serverswitcher.servers." + i + ".devserver";
        liveserver = "serverswitcher.servers." + i + ".liveserver";

        webdeveloper_setStringPreference(devserver, "");
        webdeveloper_setStringPreference(liveserver, "");
    }

    resizeCount = resizeBox.getRowCount();

    // Loop through the possible resize options
    for(i = 1; i <= resizeCount; i++)
    {
        devserver   = "serverswitcher.servers." + i + ".devserver";
        liveserver   = "serverswitcher.servers." + i + ".liveserver";
        listItem      = resizeBox.getItemAtIndex(i - 1);
        childNodes    = listItem.childNodes;

        webdeveloper_setStringPreference(devserver, listItem.childNodes[0].getAttribute("label"));
        webdeveloper_setStringPreference(liveserver, listItem.childNodes[1].getAttribute("label"));
    }

    webdeveloper_setIntegerPreference("serverswitcher.servers.count", resizeCount);

    webdeveloper_setBooleanPreference("serverswitcher.servers.changed", true); // current changes are unsaved
}
